VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Archive"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Type StdList_Entry
''name
strName As String
''size of the file
lSize As Long
'' offset in the archive
lOffset As Long
'' compressed size (if applicable)
lComSize As Long
'' compression type
strComType As String
ExtraPath As String
Deletion As Boolean
Addition As Boolean

End Type

Type StandardList
strArchive As String
Count As Long
Entry() As StdList_Entry
End Type


Type ResInfo
FNS As Long
FNB() As Byte
FO As Long
FUS As Long
FCS As Long
End Type

Type PAKTAIL
fnum As Long
RInfo() As ResInfo
End Type


Type PAKFile
Compressed As Byte
Tail_Pointer As Long
Resources() As Byte
Tail As PAKTAIL
End Type

Type NewResInfo
Off As Long
CS As Long
US As Long
NN As String
NNS As Long
End Type


Type sBuffer
Data() As Byte
RWMode As Byte
BufferPointer As Long
End Type

Type BStream
Count As Long
Buffer() As sBuffer
End Type

Dim BufStreams As BStream

'' this is the main class
Private OriginalSize As Long
Private CompressedSize As Long

Dim bChunk() As Byte
Dim strFile_Name As String
Dim lFile_OrSize As Long
Dim lFile_PkSize As Long

Dim StdList As StandardList

Dim PAK As PAKFile

Dim f

Const BS_String = 1
Const BS_Long = 2
Const BS_Int = 3
Const BS_Byte = 4
Const BS_ByteArray = 5
Const BS_READ = 1
Const BS_RW = 2
Const BS_WRITE = 3

Dim CodeTable(15, 15) As Integer

Private Function CreateCodeTable()
Dim i
Dim j
Dim cb As Integer
'Assign the start
cb = -2
cb2 = -2

For i = 0 To 15
  For j = 0 To 15
   CodeTable(i, j) = cb2
   cb2 = cb2 + 1
   If cb2 = 3 Then cb2 = -2
  Next j
  cb = cb + 1
  If cb = 3 Then cb = -2
  cb2 = cb
Next i

End Function

Private Function ToString(ByRef bb, ByVal fnum As Long) As String
Dim b As Byte

Dim s
s = UBound(bb) + 1
Dim t
Dim d As Byte
Dim code As Integer
Dim newcode As Integer
Dim xorcode As Integer
Dim brem As Integer
Dim bmul As Integer

Dim str As String
str = ""

Dim j As Byte

j = 0
Dim x As Integer: Dim y As Integer
'get the y table
y = s Mod 16
x = (s - (s Mod 16)) / 16
code = CodeTable(x, y)
'calc start xor
newcode = CInt(s * 2)
newcode = newcode + 1
newcode = newcode + code
newcode = newcode + fnum

For t = 0 To s - 1


'f = FreeFile
xorcode = newcode + j

If xorcode > 255 Then
bf = xorcode Mod 256
bmul = (xorcode - (xorcode Mod 256)) / 256
xorcode = xorcode - 255
xorcode = bf
End If

str = str & Chr(bb(t) Xor CByte(xorcode))
j = j + 2
Next t

ToString = str

End Function

Private Function FromString(OriginalName As String, ByRef bb, ByVal fnum As Long) As String
Dim b As Byte

Dim s
s = Len(OriginalName)
If s > 0 Then
ReDim bb(s - 1)

Dim t
Dim d As Byte
Dim code As Integer
Dim newcode As Integer
Dim xorcode As Integer
Dim brem As Integer
Dim bmul As Integer

'get the string in a byte buffer
For t = 0 To s - 1
bb(t) = Asc(Mid$(OriginalName, t + 1, 1))
Next t

'go excrypt
Dim str As String
str = ""

Dim j As Byte
j = 0

Dim x As Integer: Dim y As Integer
'get the y table
y = s Mod 16
x = (s - (s Mod 16)) / 16
code = CodeTable(x, y)
'calc start xor
newcode = CInt(s * 2)
newcode = newcode + 1
newcode = newcode + code
newcode = newcode + fnum

For t = 0 To s - 1


'f = FreeFile
xorcode = newcode + j

If xorcode > 255 Then
bf = xorcode Mod 256
bmul = (xorcode - (xorcode Mod 256)) / 256
xorcode = xorcode - 255
xorcode = bf
End If

str = str & Chr(bb(t) Xor CByte(xorcode))
bb(t) = bb(t) Xor CByte(xorcode)

j = j + 2
Next t

FromString = str
End If

End Function


Sub bsInit()
BufStreams.Count = 0
ReDim BufStreams.Buffer(0)
End Sub
'' Buffer streaming routines
Function bsOpen(bPath() As Byte, RWMode As Byte) As Long
Dim t, hand, Bsize

hand = 0

Bsize = UBound(bPath())

For t = 1 To BufStreams.Count
If BufStreams.Buffer(t).RWMode = 0 Then hand = t
Next
If Not hand Then
 BufStreams.Count = BufStreams.Count + 1
 hand = BufStreams.Count
End If


ReDim Preserve BufStreams.Buffer(hand)
With BufStreams.Buffer(hand)


ReDim .Data(Bsize)
CopyMemory .Data(0), bPath(0), Bsize
.RWMode = RWMode
.BufferPointer = 0
End With
bsOpen = hand


End Function

Function bsFreeMem(hand As Long)
With BufStreams.Buffer(hand)
ReDim .Data(0)
.RWMode = 0
.BufferPointer = 0
End With

End Function
Function bsGet(hand As Long, vartype As Long, Optional varsize As Long) As Variant

Dim c As Long

If hand > BufStreams.Count Then GoTo HandleWrong
If BufStreams.Buffer(hand).RWMode = 0 Then GoTo HandleWrong
If vartype > 5 Then GoTo VarTypeWrong

With BufStreams.Buffer(hand)

Select Case vartype

Case BS_String
 Dim ts As String
 ts = ""
 For c = 0 To varsize - 1
 If .BufferPointer < UBound(.Data()) Then
 ts = ts & Chr(.Data(.BufferPointer))
 .BufferPointer = .BufferPointer + 1
 End If
 Next c
 bsGet = ts

Case BS_ByteArray
 Dim tb() As Byte
 If .BufferPointer + varsize > UBound(.Data()) Then varsize = UBound(.Data()) + 1 - .BufferPointer
 ReDim tb(varsize)
 CopyMemory tb(0), .Data(.BufferPointer), varsize
 .BufferPointer = .BufferPointer + varsize
 bsGet = tb

Case BS_Long
 Dim fl As Long
 If .BufferPointer + 3 < UBound(.Data()) + 1 Then
 fl = 0
 fl = fl + CLng(.Data(.BufferPointer))
 fl = fl + CLng(.Data(.BufferPointer + 1)) * 256
 fl = fl + CLng(.Data(.BufferPointer + 2)) * 256 * 256
 fl = fl + CLng(.Data(.BufferPointer + 3)) * 256 * 256 * 256
 bsGet = fl
 .BufferPointer = .BufferPointer + 4
 Else
 bsGet = "bs_get_cant_get_long"
 End If

Case BS_Int

 If .BufferPointer + 1 < UBound(.Data()) + 1 Then
 fl = 0
 fl = fl + CLng(.Data(.BufferPointer))
 fl = fl + CLng(.Data(.BufferPointer + 1)) * 256
 bsGet = fl
 .BufferPointer = .BufferPointer + 2
 Else
 bsGet = "bs_get_cant_get_int"
 End If
End Select

End With



Exit Function

HandleWrong:
bsGet = "bs_get_wrong_handle"
Exit Function

VarTypeWrong:
bsGet = "bs_get_wrong_vartype"
Exit Function

End Function

Function bsSeek(hand As Long, Optional Seek_Set = False, Optional Position As Long) As Variant

If hand > BufStreams.Count Then GoTo HandleWrong
If BufStreams.Buffer(hand).RWMode = 0 Then GoTo HandleWrong
If Not Seek_Set Then
bsSeek = BufStreams.Buffer(hand).BufferPointer
Else
If Position < UBound(BufStreams.Buffer(hand).Data()) + 1 Then
BufStreams.Buffer(hand).BufferPointer = Position
Else
GoTo PosWrong
End If

End If

Exit Function


HandleWrong:
bsSeek = "bs_seek_wrong_handle"
Exit Function

PosWrong:
bsSeek = "bs_seek_illegal_position"
Exit Function

End Function


Sub Messager(Funct As Integer, strMess As String)

If bnVerbose Then
MsgBox strFunct(Funct) & " - " & strMess, vbOKOnly
End If
End Sub

Sub Verbose(TurnOn As Byte)

If TurnOn Then
bnVerbose = True
Messager 4, "Verbose On"
Else
bnVerbose = False
End If


End Sub

'----------------------------------------------
'' bnIdentify is boolean
'' bnIdentify examines the file to see if it is supported
Function bnIdentify(strPath As String) As Boolean
'----------------------------------------------
Dim f
Dim check As Boolean
check = False

f = FreeFile
On Error GoTo Doctor
Open strPath For Binary Access Read As f
Dim b As Byte
Dim l As Long
Get f, , b
If b >= 0 And b < 2 Then
check = True
Else
GoTo Doctor
End If
Get f, , l
If l < LOF(f) Then
check = True
Else
GoTo Doctor
End If
Seek f, l + 1
Get f, , l
If l < LOF(f) Then
check = True
Else
GoTo Doctor
End If
Get f, , l
If Seek(f) + l < LOF(f) Then
check = True
Else
GoTo Doctor
End If
Seek f, Seek(f) + l
Get f, , l
If l <> 5 Then GoTo Doctor
Close f

If check = True Then
bnIdentify = True
Else
bnIdentify = False
End If
Exit Function
Doctor:
On Error Resume Next
Close f
On Error GoTo 0
bnIdentify = False

End Function
'----------------------------------------------

'----------------------------------------------
'' bnPlugInfo returns a list of string
'' see below for meaning
Public Function bnPlugInfo(Info() As String)

ReDim Info(14)
'BELOW IS THE INFO YOU CAN EXPECT FROM A DLL
Info(0) = "Painkiller PAK Files Extractor" ' verbose meaning
Info(1) = "2" ' type = 2 , meaning you can ask it to extract/import
Info(2) = App.Major & "." & App.Minor ' version number
Info(3) = "1" ' allows importation?
Info(4) = "5" ' How many different variables will be returned
Info(5) = "0" ' is there a resource type variable? (for the columns)
Info(6) = "1" ' Create support?
Info(7) = "1" ' Delete support?
Info(8) = "1" ' Add support?
Info(9) = "1" ' Replace support?

Info(10) = "Filename" ' names of the variables returned (always at this position)
Info(11) = "Compressed"
Info(12) = "Offset"
Info(13) = "Uncompressed"
Info(14) = "Compression(%)"
End Function

Public Function iCreateFromDir(CreInfo() As String, Optional strDir As String) As Long

Dim cFiles As New colFiles

Dim pakname, res
pakname = MexGetBaseName(MexGetParentFolderName(CreInfo(0)))
'Dim CreInfo() As String
'ReDim CreInfo(0)
CreInfo(2) = 0 'force createfromdir var to 0
res = iCreateArchive(CreInfo())


cFiles.Clear
cFiles.LoadFiles strDir & "\*.*", True
 
Dim t As Long
Dim tempstr As String
Dim p
Dim temsts() As String
Dim a, b, c
ReDim temsts(cFiles.Count - 1)
Dim temppaths() As String
ReDim temppaths(cFiles.Count - 1)
c = 0
For t = 1 To cFiles.Count
If cFiles.Item(t).sFilename <> strPath Then

p = 0
p = InStr(1, cFiles.Item(t).sFilename, pakname)

If p > 0 Then
 a = Len(cFiles.Item(t).sFilename)
 b = p - 1
 If a = b - 1 Then
 tempstr = Right$(cFiles.Item(t).sFilename, Len(cFiles.Item(t).sFilename) - 3)
 Else
 tempstr = Right$(cFiles.Item(t).sFilename, a - b)
 End If

Else
tempstr = Right$(cFiles.Item(t).sFilename, Len(cFiles.Item(t).sFilename) - 3)
End If

temsts(c) = tempstr
temppaths(c) = cFiles.Item(t).sFilename
c = c + 1
Else
ReDim Preserve temsts(cFiles.Count - 2)
ReDim Preserve temppaths(cFiles.Count - 2)
End If


Next t

res = iAddResource(1, temppaths, temsts)
If res Then GoTo Doctor
'Dim list() As String

'For t = 2 To StdList.Count
'res = iChangeResourceName(StdList.Entry(t).strName, temsts(t - 2))
'If res Then GoTo Doctor
'Next t



'If strDir <> "" Then

'Dim fileNames As New Collection
'Dim filepaths As New Collection

'With pathLog
 '   .PathLogInit
 '   .fullFileNamesOnly = True
 '   .LogPath strDir
 '   Total& = .Count
 '   Set fileNames = .fullFileNames
  '  Set filepaths = .pathNames
  '  .Terminate
'End With
'End If


iCreateFromDir = 0
Exit Function
Doctor:
iCreateFromDir = 1

End Function
'----------------------------------------------
'' iExtract extracts a resource matching the full name
'' with the one in its own list
'' and to strDes (it will not create folders for you!)
Public Function iExtract(strRes As String, strDes As String) As Integer
Dim t, b
Dim Buf() As Byte
If StdList.strArchive <> "" Then
b = -1
For t = 1 To StdList.Count
If StdList.Entry(t).strName = strRes Then
b = t: t = StdList.Count + 1
End If
Next t
Dim BufSize As Long
'BufSize = 1024 * 1024
If b >= 0 Then
 BufSize = StdList.Entry(b).lComSize

 If BufSize > 0 Then
   ReDim Buf(BufSize - 1)
 Else
   ReDim Buf(BufSize)
  End If

Dim f

If StdList.Entry(b).lSize > 0 Or StdList.Entry(b).lComSize > 0 Then

 f = FreeFile
 Open StdList.strArchive For Binary Access Read As f
 Seek f, StdList.Entry(b).lOffset + 1
 Get f, , Buf
 Close f

 Dim res

 If PAK.Compressed Then

  If UBound(Buf) = 0 Then
  DoEvents
  End If
 ' If StdList.Entry(b).lSize = 0 Then StdList.Entry(b).lSize = StdList.Entry(b).lComSize
  res = DecompressData(Buf, StdList.Entry(b).lSize)
  If res Then
    Close f
    GoTo Doctor
  End If
 End If ' PAKcompressed

 On Error Resume Next
 Kill strDes
 On Error GoTo Doctor

 Open strDes For Binary Access Write As f
 If StdList.Entry(b).lSize > 0 Then Put f, , Buf
 Close f
 iExtract = 0

Else
iExtract = 0
End If ' if lSIze =0

Else
iExtract = 0
End If ' ig lcomsize = 0

Else 'if strArchive
iExtract = 1
End If

Exit Function
Doctor:
iExtract = 1
End Function



'----------------------------------------------


Private Function FreeSpace(ByVal DrvPath As String) As String

    Dim Sectors As Long 'per cluster
    Dim Bytes As Long 'per sector
    Dim FreeClusters As Long
    Dim Clusters As Long 'total

    If GetDiskFreeSpace(DrvPath, Sectors, Bytes, FreeClusters, Clusters) Then
        FreeSpace = CDbl(FreeClusters) * CDbl(Sectors) * CDbl(Bytes)
    Else
        FreeSpace = 0
    End If


    FreeSpace = FreeSpace
End Function

'' iImport replaces a given resource matching the full name
'' with the one(s) in the provided list
'' and to the (new file) strDes
'' Note that the format of the strRes() is :
'' (0) Name in PAK FILE of res1
'' (1) Path to file to replace res1
'' (2) Name in PAK FILE of res2
'' (3) Path to file to replace res2
'' etc.
Public Function iImport(strRes() As String, strDes As String, Optional Number As Long = 0, Optional OverwriteNames As Boolean = False) As Integer
Dim t, b, co
Dim Buf() As Byte
If StdList.strArchive <> "" Then

'calculate all
Dim OldSize As Long
Dim TailSize As Long
Dim HeaderSize As Long
Dim NewTailPointer As Long
Dim DataSize As Long
Dim NewDataSize As Long
Dim EsNewSize As Long
Dim ch As Byte
Dim coun
Dim RepList() As Byte
Dim NRI() As NewResInfo
OldSize = FileLen(StdList.strArchive)
TailSize = OldSize - PAK.Tail_Pointer
HeaderSize = 5
DataSize = OldSize - TailSize - HeaderSize
NewDataSize = 0
Dim NTC

NTC = (UBound(strRes) + 1) / 2

ReDim RepList(StdList.Count)
coun = 0
For t = 1 To StdList.Count
co = 0
ch = 0
If Number = 0 Then Number = NTC
While co <= Number * 2 - 1 And ch = 0 And coun < NTC
If strRes(co) = StdList.Entry(t).strName Then
coun = coun + 1
NewDataSize = NewDataSize + FileLen(strRes(co + 1))
'just astrRes rough estimate, because it will yet be compressed
ch = 1: RepList(t) = 1:
End If
co = co + 2
Wend
If ch = 0 Then
RepList(t) = 0: NewDataSize = NewDataSize + StdList.Entry(t).lComSize
End If
Next t

EsNewSize = NewDataSize + HeaderSize + TailSize

If FreeSpace(Left$(strDes, 1) & ":") > EsNewSize Then

ReDim NRI(StdList.Count)

Dim Writepath As String

Writepath = strDes
If strDes = StdList.strArchive Then Writepath = strDes & ".tmp"
Dim wf, rf, tf
rf = FreeFile

On Error Resume Next
Kill Writepath
On Error GoTo Doctor

Open StdList.strArchive For Binary Access Read As rf
wf = FreeFile

Open Writepath For Binary Access Write As wf

'write the header
Put wf, , PAK.Compressed
Put wf, , PAK.Tail_Pointer 'will be adapted later

'write all resources
co = 0
For t = 1 To StdList.Count
If RepList(t) Then
tf = FreeFile
Open strRes(co + 1) For Binary Access Read As tf
ReDim Buf(LOF(tf) - 1)
NRI(t).US = LOF(tf)
Get tf, , Buf
Close tf
If PAK.Compressed Then
res = CompressData(Buf)
NRI(t).CS = UBound(Buf) + 1
Else
NRI(t).CS = NRI(t).US
End If

If OverwriteNames Then
Dim rs As String
PAK.Tail.RInfo(t - 1).FNS = Len(strRes(co + 1))
rs = FromString(strRes(co + 1), PAK.Tail.RInfo(t - 1).FNB, t)
End If

co = co + 2
Else
Seek rf, StdList.Entry(t).lOffset + 1
ReDim Buf(StdList.Entry(t).lComSize)
If StdList.Entry(t).lComSize > 0 Then Get rf, , Buf
NRI(t).US = StdList.Entry(t).lSize
NRI(t).CS = StdList.Entry(t).lComSize
End If

'write it in the newfile
NRI(t).Off = LOF(wf)
If PAK.Compressed And NRI(t).CS > 0 Then Put wf, , Buf
If PAK.Compressed = 0 And NRI(t).US > 0 Then Put wf, , Buf



Next t

'write the tail
NewTailPointer = LOF(wf)
Put wf, , StdList.Count
For t = 1 To StdList.Count
Put wf, , PAK.Tail.RInfo(t - 1).FNS
Put wf, , PAK.Tail.RInfo(t - 1).FNB
Put wf, , NRI(t).Off
Put wf, , NRI(t).US
Put wf, , NRI(t).CS
Next t
Seek wf, 2
Put wf, , NewTailPointer
'done
Close wf
Close rf

'rename the new file to the old one, kill the other first
If strDes = StdList.strArchive Then
Kill strDes
Name Writepath As strDes
End If

Else
GoTo Doctor
End If
iImport = 0
Exit Function
End If

Doctor:
iImport = 1
On Error Resume Next
Close wf
Close rf
End Function

Public Function iDeleteResource(strRes() As String) As Long

'Dim no
Dim dumlst() As String
ReDim dumlst(0)
On Error GoTo Doctor

' search which to delete
Dim cc As Long
Dim no As Long
Dim tc, td
no = UBound(strRes) + 1
cc = 0
tc = 1

For td = 1 To StdList.Count

If strRes(tc - 1) = StdList.Entry(td).strName Then
StdList.Entry(td).Deletion = True
cc = cc + 1
tc = tc + 1
'the halt
If tc > no Then tc = no


Else
'change the new names accordingly
Dim tempstr As String
tempstr = ToString(PAK.Tail.RInfo(td - 1).FNB, td)
tempstr = FromString(tempstr, PAK.Tail.RInfo(td - 1).FNB, td - cc)
End If

Next td

GoTo Save

'save the new archive
Save:
Dim res
res = iSaveArchive(StdList.strArchive)

If res Then GoTo Doctor
Dim strArch As String
strArch = StdList.strArchive

res = iList(strArch, 1, dumlst)

iDeleteResource = 0



Exit Function

Doctor:
iDeleteResource = 1

End Function

Public Function iAddResource(Where As Long, strPath() As String, strNames() As String) As Long
Dim no
On Error GoTo Doctor
Dim tempstr As String
no = UBound(strPath) + 1
If no < 1 Then GoTo Doctor
Dim o
o = StdList.Count
StdList.Count = StdList.Count + no
'Dim tempstr As String
ReDim Preserve StdList.Entry(StdList.Count)
ReDim Preserve PAK.Tail.RInfo(StdList.Count - 1)
PAK.Tail.fnum = StdList.Count
Dim t, u
If Where <= o Then
Dim st
st = StdList.Count - o
For t = o To Where + 1 Step -1
StdList.Entry(o + st).lComSize = StdList.Entry(t).lComSize
StdList.Entry(o + st).lOffset = StdList.Entry(t).lOffset
StdList.Entry(o + st).lSize = StdList.Entry(t).lSize
StdList.Entry(o + st).strComType = StdList.Entry(t).strComType
StdList.Entry(o + st).strName = StdList.Entry(t).strName
StdList.Entry(o + st).Addition = False
StdList.Entry(o + st).ExtraPath = ""
StdList.Entry(o + st).Deletion = False

PAK.Tail.RInfo(o - 1 + st).FCS = PAK.Tail.RInfo(t - 1).FCS
tempstr = ToString(PAK.Tail.RInfo(t - 1).FNB, o + st - no)
tempstr = FromString(tempstr, PAK.Tail.RInfo(o - 1 + st).FNB, o + st)
'PAK.Tail.RInfo(o - 1 + st).FNB = PAK.Tail.RInfo(t - 1).FNB
PAK.Tail.RInfo(o - 1 + st).FNS = PAK.Tail.RInfo(t - 1).FNS
PAK.Tail.RInfo(o - 1 + st).FO = PAK.Tail.RInfo(t - 1).FO
PAK.Tail.RInfo(o - 1 + st).FUS = PAK.Tail.RInfo(t - 1).FUS
st = st - 1
Next t
Else
Where = o
End If
For t = Where + 1 To Where + no
StdList.Entry(t).lComSize = 0
StdList.Entry(t).lOffset = 0
StdList.Entry(t).lSize = 0
StdList.Entry(t).strComType = 0
StdList.Entry(t).strName = strNames(t - (Where + 1))
StdList.Entry(t).Addition = True
StdList.Entry(t).ExtraPath = strPath(t - (Where + 1))
StdList.Entry(t).Deletion = False

PAK.Tail.RInfo(t - 1).FCS = 0
tempstr = FromString(strNames(t - (Where + 1)), PAK.Tail.RInfo(t - 1).FNB, t)
PAK.Tail.RInfo(t - 1).FNS = Len(strNames(t - (Where + 1)))
PAK.Tail.RInfo(t - 1).FO = 0
PAK.Tail.RInfo(t - 1).FUS = 0
Next t

Dim res
res = iSaveArchive(StdList.strArchive)

If res Then GoTo Doctor

iAddResource = 0

Exit Function

Doctor:
iAddResource = 1


End Function


Public Function iSaveArchive(strDes As String) As Long

Dim Buf() As Byte
Dim GlobalOff As Long
On Error GoTo Doctor


If StdList.strArchive = "" Then GoTo Doctor

Dim Writepath As String

Writepath = strDes
If strDes = StdList.strArchive Then Writepath = strDes & ".tmp"
Dim wf, rf, tf
rf = FreeFile

On Error Resume Next
Kill Writepath
On Error GoTo Doctor

Open StdList.strArchive For Binary Access Read As rf
wf = FreeFile

Open Writepath For Binary Access Write As wf

'write the header
Put wf, , PAK.Compressed
Put wf, , PAK.Tail_Pointer 'will be adapted later

'write all resources
Dim t

GlobalOff = 5
Dim Del As Long
Del = 0
For t = 1 To StdList.Count
If StdList.Entry(t).Deletion = False Then
If StdList.Entry(t).Addition = False Then

Seek rf, StdList.Entry(t).lOffset + 1
StdList.Entry(t).lOffset = GlobalOff

If StdList.Entry(t).lComSize > 0 Then
ReDim Buf(StdList.Entry(t).lComSize - 1)
Get rf, , Buf
Put wf, , Buf
GlobalOff = LOF(wf)
End If

Else 'If StdList.Entry(t).Addition = False ANd .Insertion = false Then
Dim af
af = FreeFile
StdList.Entry(t).Addition = False
StdList.Entry(t).lOffset = GlobalOff

Open StdList.Entry(t).ExtraPath For Binary Access Read As af
If LOF(af) > 0 Then
ReDim Buf(LOF(af) - 1)
StdList.Entry(t).lSize = UBound(Buf) + 1
StdList.Entry(t).lComSize = UBound(Buf) + 1
Get af, , Buf
Close af
If PAK.Compressed Then
res = CompressData(Buf)
StdList.Entry(t).lComSize = UBound(Buf) + 1
End If
Put wf, , Buf
GlobalOff = LOF(wf)
Else
Close af
End If
StdList.Entry(t).ExtraPath = ""
End If

Else
Del = Del + 1
End If
'If StdList.Entry(t).Deletion = False Then


Next t

'write the tail
Dim NewTailPointer As Long

NewTailPointer = LOF(wf)
Put wf, , StdList.Count - Del
For t = 1 To StdList.Count
If StdList.Entry(t).Deletion = False Then
Put wf, , PAK.Tail.RInfo(t - 1).FNS
Put wf, , PAK.Tail.RInfo(t - 1).FNB
Put wf, , StdList.Entry(t).lOffset
Put wf, , StdList.Entry(t).lSize
Put wf, , StdList.Entry(t).lComSize
Else
DoEvents
End If

Next t
Seek wf, 2
Put wf, , NewTailPointer
'done
Close wf
Close rf

'rename the new file to the old one, kill the other first
If strDes = StdList.strArchive Then
Kill strDes
Name Writepath As strDes
End If

iSaveArchive = 0

Exit Function

Doctor:
iSaveArchive = 1
On Error Resume Next
Close wf
Close rf

End Function

Public Function iClearState() As Long
On Error GoTo Doctor
StdList.Count = 0
ReDim StdList.Entry(0)
StdList.strArchive = ""
PAK.Compressed = 0
ReDim PAK.Resources(0)
PAK.Tail.fnum = 0
ReDim PAK.Tail.RInfo(0)
PAK.Tail_Pointer = 0

iClearState = 0
Exit Function
Doctor:
iClearState = 1

End Function

'This will return the info it will need to complete a succesful creation
' of a new archive
' it will return a description and a type string
' any program calling this will have to see what it will ask the user or itself
'whenever it wants to create an archive
' also it will return the number of specification needed
Public Function iGetCreateArchiveInfo(CreateInfo() As String) As Long

ReDim CreateInfo(7)
CreateInfo(0) = "Full path of file to create"
CreateInfo(1) = "filename" 'string
CreateInfo(2) = "Compress resources Yes/No"
CreateInfo(3) = "boolean" 'byte of 0 or 1
CreateInfo(4) = "Create from Directory Yes/No"
CreateInfo(5) = "boolean" 'byte of 0 or 1
CreateInfo(6) = "Path to recursively create archive from"
CreateInfo(7) = "pathname" 'string

iGetCreateArchiveInfo = 4


End Function

Public Function iCreateArchive(CreateInfo() As String) As Long

On Error GoTo Doctor

Dim res
res = iClearState
If res Then GoTo Doctor
'create from dir?
If CLng(CreateInfo(2)) = 0 Then

StdList.strArchive = CreateInfo(0)
PAK.Compressed = CLng(CreateInfo(1))
PAK.Tail.fnum = 0
PAK.Tail_Pointer = 5
ReDim PAK.Tail.RInfo(0)
PAK.Tail.RInfo(0).FCS = 0
PAK.Tail.RInfo(0).FO = 5
PAK.Tail.RInfo(0).FUS = 0
Dim tempstr As String
tempstr = MexGetBaseName(MexGetParentFolderName(strDes)) & "\"
PAK.Tail.RInfo(0).FNS = Len(tempstr)


FromString tempstr, PAK.Tail.RInfo(0).FNB, 1
StdList.Count = 1
ReDim StdList.Entry(1)
StdList.Entry(1).lComSize = 0
StdList.Entry(1).lOffset = 5
StdList.Entry(1).lSize = 0
StdList.Entry(1).strComType = PAK.Compressed
StdList.Entry(1).strName = tempstr


res = iSaveArchive(CreateInfo(0))
If res Then GoTo Doctor

Else
'yes create from dir
res = iCreateFromDir(CreateInfo, CreateInfo(3))
If res Then GoTo Doctor

End If





iCreateArchive = 0

Exit Function

Doctor:
iCreateArchive = 1



End Function


Public Function iChangeResourceName(strSource As String, strDes As String) As Long

Dim t

If StdList.strArchive = "" Then GoTo Doctor
If strSource = strDes Then Exit Function

Dim strTemp As String
Dim Change As Boolean
Change = False

For t = 1 To StdList.Count
strTemp = ToString(PAK.Tail.RInfo(t - 1).FNB, t)
If strTemp = strSource Then
strTemp = FromString(strDes, PAK.Tail.RInfo(t - 1).FNB, t)
PAK.Tail.RInfo(t - 1).FNS = Len(strDes)
Change = True

End If
Next t

If Change = True Then
Dim res
res = iSaveArchive(StdList.strArchive)
If res Then GoTo Doctor
End If

iChangeResourceName = 0
Exit Function

Doctor:
iChangeResourceName = 1


End Function


Public Function iList(strPath As String, iType As Integer, iStdList() As String) As Long
Dim result As Long
Dim bHand As Long
Dim lCm_Offset As Long
'Dim StdList As StandardList

Messager 1, strPath & "-" & CStr(iType)
On Error GoTo Doctor

If bnIdentify(strPath) Then
iClearState
f = FreeFile
ReDim StdList.Entry(0)
StdList.Count = 0
StdList.strArchive = ""
Open strPath For Binary Access Read As f

Get f, , PAK.Compressed
Get f, , PAK.Tail_Pointer
Seek f, PAK.Tail_Pointer + 1
Get f, , PAK.Tail.fnum
ReDim PAK.Tail.RInfo(PAK.Tail.fnum - 1)

Dim t
For t = 0 To PAK.Tail.fnum - 1
Get f, , PAK.Tail.RInfo(t).FNS
ReDim PAK.Tail.RInfo(t).FNB(PAK.Tail.RInfo(t).FNS - 1)
Get f, , PAK.Tail.RInfo(t).FNB
Get f, , PAK.Tail.RInfo(t).FO
Get f, , PAK.Tail.RInfo(t).FUS
Get f, , PAK.Tail.RInfo(t).FCS
StdList.Count = StdList.Count + 1
ReDim Preserve StdList.Entry(StdList.Count)
StdList.Entry(StdList.Count).strName = ToString(PAK.Tail.RInfo(t).FNB, t + 1)
StdList.Entry(StdList.Count).lSize = PAK.Tail.RInfo(t).FUS
StdList.Entry(StdList.Count).lOffset = PAK.Tail.RInfo(t).FO
StdList.Entry(StdList.Count).lComSize = PAK.Tail.RInfo(t).FCS
StdList.Entry(StdList.Count).strComType = ZLibCom1
Next t
Close f

StdList.strArchive = strPath

ReDim iStdList((StdList.Count + 1) * 5)
iStdList(0) = CStr(StdList.Count)
iStdList(1) = StdList.strArchive
iStdList(2) = App.EXEName & CStr(App.Minor) & CStr(App.Major)

Dim d
d = 5

For t = 1 To StdList.Count
iStdList(d) = StdList.Entry(t).strName
iStdList(d + 1) = CStr(StdList.Entry(t).lComSize)
iStdList(d + 2) = CStr(StdList.Entry(t).lOffset)
iStdList(d + 3) = CStr(StdList.Entry(t).lSize)
If StdList.Entry(t).lSize > 0 Then iStdList(d + 4) = CStr(CInt(CDbl(StdList.Entry(t).lComSize) / CDbl(StdList.Entry(t).lSize) * 100))

d = d + 5
Next t
Messager 1, iStdList(0) & " files in " & iStdList(1)

Else
ReDim iStdList(2)
iStdList(0) = "File not supported"
iStdList(1) = StdList.strArchive
iStdList(2) = App.EXEName & CStr(App.Minor) & CStr(App.Major)
Messager 1, iStdList(0)
End If


Exit Function

Doctor:
ReDim StdList.Entry(0)
StdList.Count = 0
StdList.Entry(0).strName = Err.Description
Messager 1, Err.Description

End Function



Public Function CompressData(TheData() As Byte) As Long

OriginalSize = UBound(TheData) + 1

'Allocate memory for byte array
Dim BufferSize As Long
Dim TempBuffer() As Byte

BufferSize = UBound(TheData) + 1
BufferSize = BufferSize + (BufferSize * 0.01) + 12
ReDim TempBuffer(BufferSize)

Dim result As Long
'Compress byte array (data)
result = compress(TempBuffer(0), BufferSize, TheData(0), UBound(TheData) + 1)

'Truncate to compressed size
ReDim Preserve TheData(BufferSize - 1)
CopyMemory TheData(0), TempBuffer(0), BufferSize

'Cleanup
Erase TempBuffer

'Set properties if no error occurred
If result = 0 Then CompressedSize = UBound(TheData) + 1

'Return error code (if any)
CompressData = result

End Function

Public Function CompressString(TheString As String) As Long

OriginalSize = Len(TheString)

'Allocate string space for the buffers
Dim CmpSize As Long
Dim TBuff As String
Dim orgSize As Long
Dim Ret As Long
orgSize = Len(TheString)
TBuff = String(orgSize + (orgSize * 0.01) + 12, 0)
CmpSize = Len(TBuff)

'Compress string (temporary string buffer) data
Ret = compress(ByVal TBuff, CmpSize, ByVal TheString, Len(TheString))

'Set original value
OriginalSize = Len(TheString)

'Crop the string and set it to the actual string.
TheString = Left$(TBuff, CmpSize)

'Set compressed size of string.
CompressedSize = CmpSize

'Cleanup
TBuff = ""

'Return error code (if any)
CompressString = Ret

End Function

Public Function DecompressData(TheData() As Byte, OrigSize As Long) As Long

'Allocate memory for buffers
Dim BufferSize As Long
Dim TempBuffer() As Byte

BufferSize = OrigSize
BufferSize = BufferSize + (BufferSize * 0.01) + 12
ReDim TempBuffer(BufferSize)

'Decompress data
Dim result As Long
result = uncompress(TempBuffer(0), BufferSize, TheData(0), UBound(TheData) + 1)

'Truncate buffer to decompressed size
If BufferSize > 0 Then
ReDim Preserve TheData(BufferSize - 1)
End If

CopyMemory TheData(0), TempBuffer(0), BufferSize

'Reset properties
If result = 0 Then
CompressedSize = 0
OriginalSize = 0
End If

'Return error code (if any)
DecompressData = result

End Function

Public Function DecompressString(TheString As String, OrigSize As Long) As Long

'Allocate string space
Dim CmpSize As Long
Dim TBuff As String
TBuff = String(OriginalSize + (OriginalSize * 0.01) + 12, 0)
CmpSize = Len(TBuff)

'Decompress
Dim result As Long
result = uncompress(ByVal TBuff, CmpSize, ByVal TheString, Len(TheString))

'Make string the size of the uncompressed string
TheString = Left$(TBuff, CmpSize)

'Reset properties
If result = 0 Then
CompressedSize = 0
OriginalSize = 0
End If

'Return error code (if any)
Dim Ret As Long
DecompressString = Ret

End Function



Private Sub Class_Initialize()
CreateCodeTable
End Sub
